from bot_core.logging.database_logger import DatabaseLogger
from bot_data.abc.migration_abc import MigrationABC
from bot_data.db_context import DBContext


class FixUserHistoryMigration(MigrationABC):
    name = "1.2.0_FixUserHistoryMigration"

    def __init__(self, logger: DatabaseLogger, db: DBContext):
        MigrationABC.__init__(self)
        self._logger = logger
        self._db = db
        self._cursor = db.cursor

    def upgrade(self):
        self._logger.debug(__name__, "Running upgrade")

        # fix 1.1.0_AchievementsMigration
        self._cursor.execute(
            str(
                f"""ALTER TABLE UsersHistory ADD COLUMN IF NOT EXISTS ReactionCount BIGINT NOT NULL DEFAULT 0 AFTER XP;"""
            )
        )
        self._cursor.execute(
            str(
                f"""ALTER TABLE UsersHistory ADD COLUMN IF NOT EXISTS MessageCount BIGINT NOT NULL DEFAULT 0 AFTER ReactionCount;"""
            )
        )
        self._exec(__file__, "users.sql")

    def downgrade(self):
        self._cursor.execute(
            str(
                f"""
                    ALTER TABLE UsersHistory DROP COLUMN MessageCount;
                """
            )
        )
        self._cursor.execute(
            str(
                f"""
                    ALTER TABLE UsersHistory DROP COLUMN ReactionCount;
                """
            )
        )
